#include <stdio.h>
#include "mpc.h"
#include "test.h"

/*
 * This example should be run with 2 processes and tests the ability of the
 * implementation to handle a flood of one-way messages.
 */

int
main (int argc, char **argv)
{
  double wscale = 10.0, scale;
  int numprocs, myid, i, namelen;
  char processor_name[MPC_MAX_PROCESSOR_NAME];

  MPC_Init (&argc, &argv);
  MPC_Comm_size (MPC_COMM_WORLD, &numprocs);
  MPC_Comm_rank (MPC_COMM_WORLD, &myid);
  MPC_Get_processor_name (processor_name, &namelen);

  /* fprintf(stderr,"Process %d on %s\n",
     myid, processor_name); */
  for (i = 0; i < 100; i++)
    {
      MPC_Allreduce (&wscale, &scale, 1, MPC_DOUBLE, MPC_SUM, MPC_COMM_WORLD);
    }
  MPC_Finalize ();
  return 0;
}
