#include <mpc.h>
#include <stdlib.h>
#include <stdio.h>
#include "test.h"

int
main (int argc, char **argv)
{
  char *buf;
  int rank, size, i;
  MPC_Request req[10];
  MPC_Status stat[10];
  MPC_Status status;

  buf = (char *) malloc (32 * 1024);
  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);

  if (size > 10)
    return 1;

  if (rank == 0)
    {
      for (i = 1; i < size; i++)
	MPC_Isend (buf, 1024, MPC_BYTE, i, 0, MPC_COMM_WORLD, &req[i]);
      MPC_Waitall (size - 1, &req[1], &stat[1]);	/* Core dumps here! */
    }
  else
    MPC_Recv (buf, 1024, MPC_BYTE, 0, 0, MPC_COMM_WORLD, &status);

  Test_Waitforall ();
  MPC_Finalize ();
  return 0;
}

#if 0
int
MPCND_Waitall (count, array_of_requests, array_of_statuses)
     int count;
     MPC_Request array_of_requests[];
     MPC_Status array_of_statuses[];
{
  int i;
  MPCR_BOOL completed;

  for (i = 0; i < count; i++)
    {
      if (!array_of_requests[i])
	continue;
      MPCD_complete_send (&array_of_requests[i]->shandle,
			  &(array_of_statuses[i]));

      MPCND_Request_free (&array_of_requests[i]);	/* Core dumps here! */
      array_of_requests[i] = NULL;
    }
  return MPC_SUCCESS;
}


#define MPCD_ND_free_send_handle( a )  if ((a)->buffer) {FREE((a)->buffer);}

int
MPCND_Request_free (request)
     MPC_Request *request;
{
  int errno = MPC_SUCCESS;

  printf ("Should be core dumpcng here (buffer = %d)...\n",
	  (&((*request)->shandle.dev_shandle))->buffer);
  MPCD_ND_free_send_handle (&((*request)->shandle.dev_shandle));
  printf ("and not reaching here!\n");
  SBfree (MPCR_shandles, *request);

  return MPC_SUCCESS;
}
#endif
