#include <mpc.h>
#include <stdlib.h>
#include <stdio.h>
#include "test.h"

int
main (argc, argv)
     int argc;
     char **argv;
{
  char *buf;
  int i, iam;
  MPC_Init (&argc, &argv);
  MPC_Barrier (MPC_COMM_WORLD);
  buf = (char *) malloc (32 * 1024);
  MPC_Comm_rank (MPC_COMM_WORLD, &iam);
  for (i = 1; i <= 32; i++)
    {
      if (iam == 0)
	{
	  *buf = i;
	  printf ("Broadcasting %d bytes\n", i * 64);
	}
      MPC_Bcast (buf, i * 64, MPC_BYTE, 0, MPC_COMM_WORLD);
      if (*buf != i)
	printf ("Sanity check error on node %d\n", iam);
/*      gsync();
*/
      MPC_Barrier (MPC_COMM_WORLD);
    }
  Test_Waitforall ();
  MPC_Finalize ();

  return 0;
}
