#include "mpc.h"
#include <stdio.h>
#include "test.h"

int
main (int argc, char **argv)
{
  int rank, size, i;
  int data;
  int errors = 0;
  int result = -100;
  int correct_result;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);

  data = rank;

  MPC_Reduce (&data, &result, 1, MPC_INT, MPC_SUM, 0, MPC_COMM_WORLD);
  MPC_Bcast (&result, 1, MPC_INT, 0, MPC_COMM_WORLD);
  correct_result = 0;
  for (i = 0; i < size; i++)
    correct_result += i;
  if (result != correct_result)
    errors++;

  MPC_Reduce (&data, &result, 1, MPC_INT, MPC_MIN, 0, MPC_COMM_WORLD);
  MPC_Bcast (&result, 1, MPC_INT, 0, MPC_COMM_WORLD);
  if (result != 0)
    errors++;

  MPC_Reduce (&data, &result, 1, MPC_INT, MPC_MAX, 0, MPC_COMM_WORLD);
  MPC_Bcast (&result, 1, MPC_INT, 0, MPC_COMM_WORLD);
  if (result != (size - 1))
    errors++;

  Test_Waitforall ();
  MPC_Finalize ();
  if (errors)
    printf ("[%d] done with ERRORS(%d)!\n", rank, errors);
  return errors;
}
