#include "mpc.h"
#include <stdio.h>
#include "test.h"

void addem (int *, int *, int *, MPC_Datatype *);

void
addem (invec, inoutvec, len, dtype)
     int *invec, *inoutvec, *len;
     MPC_Datatype *dtype;
{
  int i;
  for (i = 0; i < *len; i++)
    inoutvec[i] += invec[i];
}

int
main (int argc, char **argv)
{
  int rank, size, i;
  int data;
  int errors = 0;
  int result = -100;
  int correct_result;
  MPC_Op op;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);

  data = rank;
  MPC_Op_create ((MPC_User_function *) addem, 1, &op);
  MPC_Reduce (&data, &result, 1, MPC_INT, op, 0, MPC_COMM_WORLD);
  MPC_Bcast (&result, 1, MPC_INT, 0, MPC_COMM_WORLD);
  MPC_Op_free (&op);
  correct_result = 0;
  for (i = 0; i < size; i++)
    correct_result += i;
  if (result != correct_result)
    errors++;

  Test_Waitforall ();
  MPC_Finalize ();
  if (errors)
    printf ("[%d] done with ERRORS(%d)!\n", rank, errors);
  return errors;
}
