/* 	$Id: grouptest.c,v 1.1 2006/06/06 07:44:13 perache Exp $	 */

#include "mpc.h"
#include <stdio.h>
#include "test.h"

int
main (int argc, char **argv)
{
  int rank, size, i;
  MPC_Group group1, group2, group3, groupall, groupunion, newgroup;
  MPC_Comm newcomm;
  int ranks1[100], ranks2[100], ranks3[100];
  int nranks1 = 0, nranks2 = 0, nranks3 = 0;

  MPC_Init (&argc, &argv);
  MPC_Barrier (MPC_COMM_WORLD);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);
  MPC_Comm_group (MPC_COMM_WORLD, &groupall);

  /* Divide groups */
  for (i = 0; i < size; i++)
    if ((i % 3) == 0)
      ranks1[nranks1++] = i;
    else if ((i % 3) == 1)
      ranks2[nranks2++] = i;
    else
      ranks3[nranks3++] = i;

  MPC_Group_incl (groupall, nranks1, ranks1, &group1);
  MPC_Group_incl (groupall, nranks2, ranks2, &group2);
  MPC_Group_incl (groupall, nranks3, ranks3, &group3);

  MPC_Group_difference (groupall, group2, &groupunion);

  MPC_Comm_create (MPC_COMM_WORLD, group3, &newcomm);
  newgroup = MPC_GROUP_NULL;
  if (newcomm != MPC_COMM_NULL)
    {
      /* If we don't belong to group3, this would fail */
      MPC_Comm_group (newcomm, &newgroup);
    }

  /* Free the groups */
  MPC_Group_free (&groupall);
  MPC_Group_free (&group1);
  MPC_Group_free (&group2);
  MPC_Group_free (&group3);
  MPC_Group_free (&groupunion);
  if (newgroup != MPC_GROUP_NULL)
    {
      MPC_Group_free (&newgroup);
    }

  /* Free the communicator */
  if (newcomm != MPC_COMM_NULL)
    MPC_Comm_free (&newcomm);
  Test_Waitforall ();
  MPC_Finalize ();
  return 0;
}
