#include "mpc.h"
#include <stdio.h>
typedef struct
{
  short a;
  int b;
} s1;

int
main (int argc, char **argv)
{
  s1 s[10], sout[10];
  int i, rank;
  MPC_Status status;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  for (i = 0; i < 10; i++)
    {
      s[i].a = rank + i;
      s[i].b = rank;
      sout[i].a = -1;
      sout[i].b = -1;
    }
/* MPC_Allreduce( s, sout, 10, MPC_SHORT_INT, MPC_MINLOC, MPC_COMM_WORLD ); */
/* if (rank == 1) 
    for (i=0; i<10; i++) 
	sout[i] = s[i];
 */
  MPC_Reduce (s, sout, 10, MPC_SHORT_INT, MPC_MINLOC, 1, MPC_COMM_WORLD);
  if (rank == 1)
    for (i = 0; i < 10; i++)
      {
	printf ("[%d] (%x,%x)\n", rank, (int) sout[i].a, sout[i].b);
      }
  if (rank == 1)
    MPC_Send (sout, 10, MPC_SHORT_INT, 0, 0, MPC_COMM_WORLD);
  else if (rank == 0)
    MPC_Recv (sout, 10, MPC_SHORT_INT, 1, 0, MPC_COMM_WORLD, &status);
/* MPC_Bcast( sout, 10, MPC_SHORT_INT, 1, MPC_COMM_WORLD ); */
  for (i = 0; i < 10; i++)
    {
      printf ("[%d] (%x,%x)\n", rank, (int) sout[i].a, sout[i].b);
    }
  MPC_Finalize ();
  return 0;
}
