#include <stdio.h>
#include "mpc.h"
#include "test.h"

int
main (int argc, char **argv)
{
  int rank, np, data = 777;
  MPC_Request handle;
  MPC_Status status;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &np);

  if (np < 4)
    {
      MPC_Finalize ();
      printf ("4 processors or more required, %d done\n", rank);
      return (1);
    }

  if (rank == 0)
    {
      MPC_Isend (&data, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 2, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 2, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
    }
  else if (rank == 1)
    {
      MPC_Irecv (&data, 1, MPC_INT, 0, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 0, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 3, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 3, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
    }
  else if (rank == 2)
    {
      MPC_Isend (&data, 1, MPC_INT, 3, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 3, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 0, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 0, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
    }
  else if (rank == 3)
    {
      MPC_Irecv (&data, 1, MPC_INT, 2, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 2, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Irecv (&data, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
      MPC_Isend (&data, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &handle);
      MPC_Wait (&handle, &status);
    }
  Test_Waitforall ();
  MPC_Finalize ();
  return (0);
}
