#include "mpc.h"
#include <stdio.h>

#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif

/* 
   This is a very simple MPC program which can be used to check things
   like the behavior of the ADI or heterogeneous code
 */
int
main (int argc, char **argv)
{
  char msg[10];
  char smsg[10];
  int rank, size;
  int src, dest;
  int count;
  MPC_Status status;

  MPC_Init (&argc, &argv);
  MPC_Comm_size (MPC_COMM_WORLD, &size);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
/* if (size != 2) { */
/*     MPC_Abort( MPC_COMM_WORLD, 1 ); */
/*     return 1; */
/*     } */
  src = 1;
  dest = 0;
  if (rank == src)
    {
      strcpy (msg, "MPCCH!");
      MPC_Send (msg, 7, MPC_CHAR, dest, 10, MPC_COMM_WORLD);
    }
  else if (rank == dest)
    {
      MPC_Recv (smsg, 10, MPC_CHAR, src, 10, MPC_COMM_WORLD, &status);
      if (status.MPC_TAG != 10)
	{
	  fprintf (stderr, "Error in status tag!\n");
	  MPC_Abort (MPC_COMM_WORLD, 1);
	}
      if (status.MPC_SOURCE != src)
	{
	  fprintf (stderr, "Error in status source!\n");
	  MPC_Abort (MPC_COMM_WORLD, 1);
	}
      MPC_Get_count (&status, MPC_CHAR, &count);
      if (count != 7)
	{
	  fprintf (stderr, "Error in count, got %d expected 7\n", count);
	  MPC_Abort (MPC_COMM_WORLD, 1);
	}
      if (strcmp (smsg, "MPCCH!"))
	{
	  fprintf (stderr, "Got wrong msg (%s), expected \"MPCCH!\"\n", smsg);
	  MPC_Abort (MPC_COMM_WORLD, 1);
	}
    }

  MPC_Finalize ();
  return 0;
}
