/*
   MPCCH 1.0.8 on Intel Paragons is alleged to have failed this test.
   (Original code from 
    From: weber@zam212.zam.kfa-juelich.de (M.Weber)
    Reply-To: M.Weber@kfa-juelich.de
   modified slightly to meet our test rules.)
 */
#include <stdio.h>
#include "mpc.h"
#define SIZE 100
/* SIZE 16 worked on Paragon */

#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif

int
main (int argc, char *argv[])
{
  int num_procs, my_id, flag;
  int buf[SIZE][SIZE];
  MPC_Status status;
  MPC_Request handle;

  MPC_Init (&argc, &argv);
  MPC_Comm_size (MPC_COMM_WORLD, &num_procs);
  MPC_Comm_rank (MPC_COMM_WORLD, &my_id);

  if (my_id == 1)
    {
      MPC_Isend (buf, SIZE * SIZE, MPC_INT, 0, 0, MPC_COMM_WORLD, &handle);

      flag = 0;
      while (flag == 0)
	{
	  MPC_Test (&handle, &flag, &status);
	  printf ("%d Wait for completition flag = %d handle = %ld ....\n",
		  my_id, flag, (long) &handle);
	}
    }
  else if (my_id == 0)
    {
      MPC_Recv (buf, SIZE * SIZE, MPC_INT, 1, 0, MPC_COMM_WORLD, &status);
    }

  printf ("%d Done ....\n", my_id);

  MPC_Finalize ();
  return 0;
}
