#include <stdio.h>
#include "mpc.h"

int
main (int argc, char **argv)
{
  int rank, size;
  MPC_Request r1, r2;
  MPC_Status s;
  int buf[10000], buf2[10000], count, tag1, tag2;

  count = 10000;
  tag1 = 100;
  tag2 = 1000;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);

  if (rank == 0)
    {
      MPC_Isend (buf, count, MPC_INT, 1, tag1, MPC_COMM_WORLD, &r1);
      MPC_Isend (buf2, count, MPC_INT, 1, tag2, MPC_COMM_WORLD, &r2);
      MPC_Wait (&r1, &s);
      MPC_Wait (&r2, &s);
    }
  else if (rank == 1)
    {
      MPC_Irecv (buf2, count, MPC_INT, 0, tag2, MPC_COMM_WORLD, &r2);
      MPC_Irecv (buf, count, MPC_INT, 0, tag1, MPC_COMM_WORLD, &r1);
      MPC_Wait (&r2, &s);
      if (s.MPC_TAG != tag2)
	{
	  printf ("Error in receive order\n");
	}
      MPC_Wait (&r1, &s);
    }

  MPC_Barrier (MPC_COMM_WORLD);
  if (rank == 0)
    {
      printf ("Test completed\n");
    }
  MPC_Finalize ();
  return 0;
}
