#include <stdio.h>
#include "mpc.h"

#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif


int
main (int argc, char *argv[])
{
  int easy;
  int rank;
  int size;
  int a;
  int b;
  MPC_Request request;
  MPC_Status status;
  double t1;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);
  MPC_Comm_size (MPC_COMM_WORLD, &size);

  /* This test depends on a working wtime.  Make a simple check */
/*     t0 = MPC_Wtime(); */
/*     if (t0 == 0 && MPC_Wtime() == 0) { */
/* 	fprintf( stderr,  */
/* 		 "MPC_WTIME is returning 0; a working value is needed\n\ */
/* for this test.\n" ); */
/* 	MPC_Abort( MPC_COMM_WORLD, 1 ); */
/*     } */

  easy = 1;

  MPC_Barrier (MPC_COMM_WORLD);
  if (rank == 0)
    {
      MPC_Irecv (&a, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &request);
      MPC_Recv (&b, 1, MPC_INT, 1, 0, MPC_COMM_WORLD, &status);
      MPC_Wait (&request, &status);
      /* Check for correct values: */
      if (a == 1 && b == 2)
	{
	  printf (" No Errors\n");
	}
      else
	{
	  printf ("rank = %d, a = %d, b = %d\n", rank, a, b);
	}
    }
  else if (rank == 1)
    {
      t1 = MPC_Wtime ();
      while (MPC_Wtime () - t1 < easy);
      a = 1;
      b = 2;
      MPC_Send (&a, 1, MPC_INT, 0, 0, MPC_COMM_WORLD);
      MPC_Send (&b, 1, MPC_INT, 0, 0, MPC_COMM_WORLD);
    }


  MPC_Finalize ();
  return 0;
}
