/* 
   This is a test of probe to receive a message of unknown length
 */

#include <stdio.h>
#include "mpc.h"
#include "test.h"

int
main (int argc, char **argv)
{
  int data, to, from, tag, maxlen, np, myid, src, dest;
  MPC_Status status;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &myid);
  MPC_Comm_size (MPC_COMM_WORLD, &np);

/* dest writes out the received stats; for the output to be
   consistant (with the final check), it should be procees 0 */
  if (argc > 1 && argv[1] && strcmp ("-alt", argv[1]) == 0)
    {
      dest = np - 1;
      src = 0;
    }
  else
    {
      src = np - 1;
      dest = 0;
    }

  if (myid == src)
    {
      to = dest;
      tag = 2000;
#ifdef VERBOSE
      printf ("About to send\n");
#endif
      MPC_Send (&data, 1, MPC_INT, to, tag, MPC_COMM_WORLD);
    }
  else if (myid == dest)
    {
      tag = 2000;
      from = MPC_ANY_SOURCE;
      MPC_Probe (from, tag, MPC_COMM_WORLD, &status);
      MPC_Get_count (&status, MPC_INT, &maxlen);
      /* Here I'd normally allocate space; I'll just check that it is ok */
      if (maxlen > 1)
	printf ("Error; size = %d\n", maxlen);
#ifdef VERBOSE
      printf ("About to receive\n");
#endif
      MPC_Recv (&data, 1, MPC_INT, status.MPC_SOURCE, status.MPC_TAG,
		MPC_COMM_WORLD, &status);
    }
  MPC_Barrier (MPC_COMM_WORLD);
  Test_Waitforall ();
  MPC_Finalize ();
  return 0;
}
