/* 
   This is a test of probe to receive a message of unknown type (used as a
   server)
 */
#include <stdio.h>
#include "mpc.h"
#include "test.h"

int
main (int argc, char **argv)
{
  int data, to, from, tag, maxlen, np, myid, flag, dest, src;
  MPC_Status status, status1;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &myid);
  MPC_Comm_size (MPC_COMM_WORLD, &np);

/* dest writes out the received stats; for the output to be
   consistant (with the final check), it should be procees 0 */
  if (argc > 1 && argv[1] && strcmp ("-alt", argv[1]) == 0)
    {
      dest = np - 1;
      src = 0;
    }
  else
    {
      src = np - 1;
      dest = 0;
    }

  if (myid == src)
    {
      to = dest;
      tag = 2000;
#ifdef VERBOSE
      printf ("About to send\n");
#endif
      MPC_Send (&data, 1, MPC_INT, to, tag, MPC_COMM_WORLD);
      tag = 2001;
#ifdef VERBOSE
      printf ("About to send 'done'\n");
#endif
      MPC_Send (&data, 1, MPC_INT, to, tag, MPC_COMM_WORLD);
    }
  else if (myid == dest)
    {
      /* Server loop */
      while (1)
	{
	  tag = MPC_ANY_TAG;
	  from = MPC_ANY_SOURCE;
	  /* Should really use MPC_Probe, but functionally this will work
	     (it is less efficient, however) */
	  do
	    {
	      MPC_Proceed ();
	      MPC_Iprobe (from, tag, MPC_COMM_WORLD, &flag, &status);
	    }
	  while (!flag);
	  if (status.MPC_TAG == 2001)
	    {
#ifdef VERBOSE
	      printf ("Received terminate message\n");
#endif
	      /* Actually need to receive it ... */
	      MPC_Recv (&data, 1, MPC_INT, status.MPC_SOURCE,
			status.MPC_TAG, MPC_COMM_WORLD, &status1);
	      break;
	    }
	  if (status.MPC_TAG == 2000)
	    {
	      MPC_Get_count (&status, MPC_INT, &maxlen);
	      if (maxlen > 1)
		printf ("Error; size = %d\n", maxlen);
#ifdef VERBOSE
	      printf ("About to receive\n");
#endif
	      MPC_Recv (&data, 1, MPC_INT, status.MPC_SOURCE,
			status.MPC_TAG, MPC_COMM_WORLD, &status1);
	    }
	}
    }
  MPC_Barrier (MPC_COMM_WORLD);
  Test_Waitforall ();
  MPC_Finalize ();
  return 0;
}
