#include "mpc.h"
#include <stdio.h>
#include <stdlib.h>

#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif

/*
 * This needs to test long messages as well as short ones.
 * The most likely failure mode for this program is that it will
 * hang.  Sorry about that....
 *
 */
int
main (int argc, char **argv)
{
  int sendbuf[10];
  int sendcount = 10;
  int recvbuf[10];
  int recvcount = 10;
  int source = 0, recvtag = 2;
  int dest = 0, sendtag = 2;
  int i, *longsend, *longrecv;

  int mpc_errno = MPC_SUCCESS;
  MPC_Status status_array[2];
  MPC_Request req[2];
  int myid;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &myid);
  if (myid == 0)
    {
      if ((mpc_errno = MPC_Irecv (recvbuf, recvcount, MPC_INT,
				  source, recvtag, MPC_COMM_WORLD, &req[1])))
	return mpc_errno;
      if ((mpc_errno = MPC_Isend (sendbuf, sendcount, MPC_INT, dest,
				  sendtag, MPC_COMM_WORLD, &req[0])))
	return mpc_errno;

      fprintf (stdout, "[%d] Starting waitall\n", 0);
      mpc_errno = MPC_Waitall (2, req, status_array);
      fprintf (stdout, "[%d] Ending waitall\n", 0);

      for (i = 16; i < 257000; i *= 2)
	{
	  longsend = (int *) malloc (i * sizeof (int));
	  longrecv = (int *) malloc (i * sizeof (int));
	  if (!longsend || !longrecv)
	    {
	    }
	  if ((mpc_errno = MPC_Irecv (longrecv, i, MPC_INT, source, recvtag,
				      MPC_COMM_WORLD, &req[1])))
	    return mpc_errno;
	  if ((mpc_errno = MPC_Isend (longsend, i, MPC_INT, dest, sendtag,
				      MPC_COMM_WORLD, &req[0])))
	    return mpc_errno;

	  fprintf (stdout, "[%d] Starting waitall (%d)\n", 0, i);
	  mpc_errno = MPC_Waitall (2, req, status_array);
	  fprintf (stdout, "[%d] Ending waitall\n", 0);

	  free (longsend);
	  free (longrecv);
	}
    }

  MPC_Finalize ();
  return (mpc_errno);
}
