/*
 * Test from oertel@ZIB-Berlin.DE 
 */

/*
 * Test of MPC_Ssend on MPC implementation on Cray T3D
 *
 * Process dest should receive numbers 1,...,10 but
 * receives 274878030344 instead !!!
 *
 * Test program works correctly with MPC_Ssend replaced by MPC_Send!
 *
 *
 * Compcler options: /mpp/bin/cc -Tcray-t3d -g -X2 -I"directory of mpc.h"
 *
 * Output of run with option -mpcversion:

ssendt3d -mpcversion
MPC model implementation 1.00.11., T3D Device Driver, Version 0.0
MPC model implementation 1.00.11., T3D Device Driver, Version 0.0
Configured with -arch=cray_t3d -device=t3d -opt=-g -ar_nolocal -make=gmake
Configured with -arch=cray_t3d -device=t3d -opt=-g -ar_nolocal -make=gmake
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072
Received 274878008072

 */

#include <stdio.h>
#include "mpc.h"


#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif

#define SIZE 10

static int src = 0;
static int dest = 1;

int
main (int argc, char **argv)
{
  int rank;			/* My Rank (0 or 1) */
  int i, ivalue;
  MPC_Status Stat;

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &rank);

  if (rank == src)
    {

      for (i = 1; i <= SIZE; i++)
	{
	  MPC_Ssend (&i, 1, MPC_INT, dest, 2000, MPC_COMM_WORLD);
	}

    }
  else if (rank == dest)
    {

      for (i = 1; i <= SIZE; i++)
	{
	  MPC_Recv (&ivalue, 1, MPC_INT, src, 2000, MPC_COMM_WORLD, &Stat);
	  printf ("Received %d\n", ivalue);
	  fflush (stdout);
	}
    }

  MPC_Barrier (MPC_COMM_WORLD);
  MPC_Finalize ();

  return 0;
}
