/*
 * This code tests waitany; in one version of MPCCH, it uncovered some
 * problems with the ADI Test calls.
 */
																											 /* #define i_ntotin 256  *//* ok    */
																											 /* #define i_ntotin 257  *//* fails */
#define i_ntotin 256		/* fails */

#include <stdio.h>
#include "mpc.h"

#if defined(NEEDS_STDLIB_PROTOTYPES)
#include "protofix.h"
#endif

#define DAR 32			/* ``Data: ARray''  */


int
main (int argc, char **argv)
{
  int locId;
  int data[i_ntotin];

  MPC_Init (&argc, &argv);
  MPC_Comm_rank (MPC_COMM_WORLD, &locId);

  if (locId == 0)
    {

      /* The server... */

      MPC_Status status[2];
      MPC_Request events[2];

      int eventId;

      int dstId = 1;

      int i;

      for (i = 0; i < i_ntotin; i++)
	data[i] = i + 1;

      events[0] = MPC_REQUEST_NULL;
      events[1] = MPC_REQUEST_NULL;

      MPC_Isend (data, i_ntotin, MPC_INT, dstId, DAR,
		 MPC_COMM_WORLD, events + 1);
      /* enable send of data */

    /*_begin_trace_code  */
      /* printf("locId = %d: MPC_Isend(%x, %d, %x, %d, %d, %x, %x)\n",
         locId, data, i_ntotin, MPC_INT, dstId, DAR, MPC_COMM_WORLD, events [1]); 
       */
    /*_end_trace_code  */

    /*_begin_trace_code  */
      /* printf("locId = %d: MPC_Waitany(%d, [%x, %x], %x %x)...",
         locId, 2, events [0], events [1], &eventId, &status) ; */
    /*_end_trace_code  */

      MPC_Waitany (2, events, &eventId, status);

    /*_begin_trace_code  */
      printf ("done.  eventId = %x\n", eventId);
    /*_end_trace_code  */
    }

  if (locId == 1)
    {

      /* The Client...  */

      MPC_Status status;

      int srcId = MPC_ANY_SOURCE;

    /*_begin_trace_code  */
      /*
         printf("locId = %d: MPC_Recv(%x, %d, %x, %d, %d, %x, %x)...",
         locId, data, i_ntotin, MPC_INT, srcId, DAR, MPC_COMM_WORLD, &status) ;
       */
    /*_end_trace_code  */

      MPC_Recv (data, i_ntotin, MPC_INT, srcId, DAR, MPC_COMM_WORLD, &status);

    /*_begin_trace_code  */
      /*printf("done.\n") ; */
    /*_end_trace_code  */

      /*
         printf("locId = %d: data [0] = %d, data [%d] = %d\n",
         locId, data [0], i_ntotin - 1, data [i_ntotin - 1]) ;
       */
    }

  MPC_Barrier (MPC_COMM_WORLD);
  if (locId == 0)
    printf ("Test complete\n");
  MPC_Finalize ();
  return 0;
}
